unit MyAssertions;

interface

	uses
		Types;

{$setc do_debug := 1}

{$ifc not do_debug}
{$definec Assert(b)}
{$definec SafeDebugStr(s)}
{$elsec}
{$definec Assert(b) AssertCode(b)}
{$definec SafeDebugStr(b) DebugStr(s)}
{$endc}
{ $ definec DontDebugStr(s)}

	procedure DontDebugStr( s: Str255 ); { broken bloody compiler }

	procedure AssertCode (b: boolean);
	procedure AssertValidPtr (p: univ Ptr);
	procedure AssertValidPtrNil (p: univ Ptr);
	procedure AssertValidHandle (hhhh: univ Handle);
	procedure AssertValidHandleNil (hhhh: univ Handle);

implementation

	uses
		Memory;

	procedure DontDebugStr( s: Str255 ); { broken bloody compiler }
	begin
	end;
	
	procedure AssertCode (b: boolean);
	begin
{$ifc do_debug}
		if not b then begin
			DebugStr('Assert Failed;sc;hc');
		end;
{$endc}
	end;

	procedure AssertValidPtr (p: univ Ptr);
	begin
{$ifc do_debug}
		Assert((p <> nil) & (not odd(ord4(p))));
{$endc}
	end;

	procedure AssertValidPtrNil (p: univ Ptr);
	begin
{$ifc do_debug}
		if p <> nil then begin
			AssertValidPtr(p);
		end;
{$endc}
	end;

	procedure AssertValidHandle (hhhh: univ Handle);
	begin
{$ifc do_debug}
		AssertValidPtr(hhhh);
		AssertValidPtr(hhhh^);
		Assert(RecoverHandle(hhhh^) = hhhh);
{$endc}
	end;

	procedure AssertValidHandleNil (hhhh: univ Handle);
	begin
{$ifc do_debug}
		if hhhh <> nil then begin
			AssertValidHandle(hhhh);
		end;
{$endc}
	end;
	
end.


