program SystemWatcher;

	uses
		Folders, Files, Errors, TextUtils, 
		MyInitialization, MyFileSystemUtils, MyStrH, MyStrings, MyUtils;
	
	var
		output_refnum: integer;
		output_data: Handle;
		last_wne_time: longint;

	procedure WNE;
		var
			dummy:Boolean;
			er:EventRecord;
	begin
		if TickCount > last_wne_time+4 then begin
			last_wne_time := TickCount;
			dummy:=WaitNextEvent(everyEvent,er,0,nil);
		end;
	end;

	function DoOutput: OSErr;
	begin
		HLock( output_data );
		DoOutput := MyFSWrite( output_refnum, GetHandleSize( output_data ), output_data^ );
		HUnlock( output_data );
		SetHandleSize( output_data, 0 );
	end;
	
	function SanitizeString( s: Str255 ): Str255;
		var
			i: integer;
	begin
		i := 1;
		while i <= length(s) do begin
			if (s[i] < spc) or (s[i] = '%') then begin
				Insert( HexN2( ord(s[i]) ), s, i+1 );
				s[i] := '%';
				i := i + 3;
			end else begin
				i := i + 1;
			end;
		end;
		SanitizeString := s;
	end;
	
	function Doit( var fs:FSSpec; folder:boolean; path:Str255; var pb:CInfoPBRec ):boolean;
		var
			s: Str255;
			junk: OSErr;
	begin
		if folder then begin
			Doit := true;
		end else begin
			s := SanitizeString( OSTypeToString(pb.ioFlFndrInfo.fdCreator) ) + 
						'/' + SanitizeString( OSTypeToString(pb.ioFlFndrInfo.fdType) ) + 
						tab + NumToStr( pb.ioFlLgLen ) +
						tab + NumToStr( pb.ioFlRLgLen ) +
						tab + UNumToStr( pb.ioFlCrDat ) +
						tab + UNumToStr( pb.ioFlMdDat ) +
						tab + SanitizeString( path + fs.name ) +
						cr;
			junk := PtrAndHand( @s[1], output_data, length(s) );
			if GetHandleSize( output_data ) > 50000 then begin
				junk := DoOutput;
			end;
			Doit := false;
		end;
		WNE;
	end;

	var
		err, err2, junk: OSErr;
		system_spec, pref_spec: FSSpec;
		date: UInt32;
		s, dates, times: Str255;
begin
	Initialization;
	last_wne_time := TickCount;
	err := FindFolder( kOnSystemDisk, kSystemFolderType, false, system_spec.vRefNum, system_spec.parID );
	if GetIndStr( 128, 3 ) <> 'system folder only' then begin
		system_spec.parID := 2;
	end;
	system_spec.name := '';
	if err = noErr then begin
		err := FindFolder( kOnSystemDisk, kPreferencesFolderType, true, pref_spec.vRefNum, pref_spec.parID );
		pref_spec.name := GetIndStr( 128, 1 );
	end;
	output_data := NewHandle(0);
	if err = noErr then begin
		junk := FSpCreate( pref_spec, 'R*ch', 'TEXT', 0 );
		err := FSpOpenDF( pref_spec, fsRdWrPerm, output_refnum );
		if err = noErr then begin
			err := SetFPos( output_refnum, fsFromLEOF, 0 );
			if err = noErr then begin
				GetIndString( s, 128, 2 );
				GetDateTime( date );
				IUDateString( date, longDate, dates);
				IUTimeString( date, true, times );
				SPrintS3( s, s, dates, times, '' );
				err := MyFSWriteString( output_refnum, s );
			end;
			if err = noErr then begin
				err := ScanDirectory( system_spec, Doit );
			end;
			if err = noErr then begin
				err := DoOutput;
			end;
			err2 := FSClose( output_refnum );
			if err = noErr then begin
				err := err2;
			end;
		end;
	end;
	
end.
